##parameters=theme=None, edit=None, REQUEST=None

if REQUEST is not None:
   RESPONSE = REQUEST.RESPONSE
   RESPONSE.setHeader('Content-Type', 'text/css')
   if edit:
      RESPONSE.setHeader('Expires', 'Sat, 1 Jan 2000 00:00:00 GMT')
      RESPONSE.setHeader('Pragma', 'no-cache')
   else:
      RESPONSE.setHeader('Cache-Control','public, max-age=3600')

tmtool = context.portal_themes
container = tmtool.getEffectiveThemeContainer(theme=theme)
ramcache = tmtool.getRAMCache()

styles_dir = container.getStylesFolder()
if styles_dir is None:
    return

cpsskins_render = context.cpsskins_render

css = ''
for obj in styles_dir.objectValues():
    o = obj.aq_explicit
    if hasattr(o, 'isPortalStyle'):
        if o.isPortalStyle():
            try:
                if edit or not ramcache:
                    css += obj.render() 
                else:
                    css += cpsskins_render(obj)
            except:
                pass

return css
