##parameters=theme=None, edit_mode=None, REQUEST=None, **kw

if REQUEST is not None:
    kw.update(REQUEST.form)

tmtool = context.portal_themes
templet = context.addTemplet(**kw)

if templet:
    url = templet.absolute_url() + '/edit_form'
    if theme is not None and edit_mode is not None:
        url += '?theme=%s&edit_mode=%s&cat=general' \
                % (theme, edit_mode)

    default_styles = {}
    for category in templet.getApplicableStyles():
        style_propid =  category['id']
        style = getattr(context, style_propid, None)
        styles = tmtool.findStylesByContext(category=category['meta_type'], \
                                            object=templet, title=style)
        if styles:
           if styles['object']:
               style_title = getattr(styles['object'][0], 'title', None)
               default_styles[style_propid] = style_title
    if default_styles:
        templet.edit(**default_styles)
else:
    return

if REQUEST is not None:
   REQUEST.RESPONSE.redirect(url)
else:
   return templet
