##parameters=obj=None, context_obj=None

if obj is None or context_obj is None:
   return 

REQUEST = context.REQUEST
tmtool = context.portal_themes
portal_url = context.portal_url(relative=0)
request_url = REQUEST.get('URL', None)
query_string = REQUEST.get('QUERY_STRING', None)

action_categories = getattr(obj, 'action_categories', None) 
custom_action_categories = getattr(obj, 'custom_action_categories', []) 
show_action_icons = getattr(obj, 'show_action_icons', None) 
invisible_actions = getattr(obj, 'invisible_actions', []) 

categories = action_categories
if custom_action_categories:
    if custom_action_categories[0] != '':
       categories = categories + custom_action_categories

actions = REQUEST.get('cmfactions', None)
if actions is None:
    actions = context.portal_actions.listFilteredActionsFor(context_obj)

actioninfo = []

getIconFor = tmtool.getIconFor
firstcat = 1
for category in categories:
    actions_by_cat = actions.get(category, [])

    if firstcat:
       newcat = 0
    elif one_action_is_visible:
       newcat = 1
    one_action_is_visible = 0
    for action in actions_by_cat:
        action_id = action['id']
        if action_id not in invisible_actions:
            one_action_is_visible = 1
            action_url = action['url']

            we_are_here = 0
            url = action_url
            if url[-1:] == '/':
                url = url[:-1]
            if request_url[-11:] == '/index_html':
                request_url = request_url[:-11]
            if query_string:
                request_url += '?' + query_string
            if url == request_url: 
                we_are_here = 1

            menustyle = ''
            if show_action_icons:
                icon = getIconFor(category, action_id)
                if icon:
                    menustyle = 'background: url(%s/%s) no-repeat' % (portal_url, icon) 
            if we_are_here:
                menuclass = 'submenuin'
            else:
                menuclass = 'submenuout'

            actioninfo.append({
                'we_are_here': we_are_here,
                'title': action['name'],
                'url': action_url,
                'class': menuclass,
                'style': menustyle,
                'newcat': newcat,
                }
            ) 
            newcat = 0 
    firstcat = 0
return actioninfo
